# SkiaSharp Samples

This folder contains many samples to demonstrate both platforms and features. If you download this repository and want to test builds or make changes to the library, then you are in the right place.

> If you want to modify the libraries and/or samples, but don't have all the machines to build all the native libraries, check out this [guide to downloading the pre-built native libraries][skip].

If you are looking to try out the samples, but are not looking to build this repository, then check out the [samples.zip file on each release][samples].

## This Folder

There are 2 main types of sample apps in this folder:

 1. **Basic**  
    Demonstrates the simplest way to use SkiaSharp on a particular platform.
 1. **Gallery**  
    Each app contains several sample drawing to demonstrate different features
    of SkiaSharp.

The "AppStoreCertificates" folder just contains the keystores and certificates to build the samples. This is more fore CI so it can build Release apps, so feel free to use your own.

## Basic Samples

There are several simple samples, each of which demonstrate the simplest way to use SkiaSharp on a particular platform.

Currently there are samples for all the supported platforms, and variations of frameworks on them:

 - .NET Core
 - Android
 - Docker
 - GTK (v2 and v3)
 - iOS
 - macOS
 - Tizen (Xamarin.Forms and ElmSharp)
 - tvOS
 - UWP
 - watchOS
 - Windows.Forms
 - WPF
 - Xamarin.Forms (Android, macOS, Tizen, UWP, iOS, WPF)

## Gallery Samples

For more complex samples that demonstrates specific features, there is a nice gallery app for several platforms:

 - macOS
 - tvOS
 - UWP
 - Windows.Forms
 - WPF
 - Xamarin.Forms (Android, macOS, Tizen, UWP, iOS, WPF)

[samples]: https://github.com/mono/SkiaSharp/releases
[skip]: https://github.com/mono/SkiaSharp/wiki/Building-SkiaSharp#preparation-1
